
#ifndef _AUDIO_H
#define _AUDIO_H

#ifdef SDL
#include "sdl.h"
#endif
#include "def.h"

#ifdef __cplusplus
extern "C" {
#endif

#define AUDIO_BLOCKLENGTH  (735)                                 // size in samples of one sound frame
#define AUDIO_NUMBLOCKS    (8)                                   // number of blocks
#define AUDIO_BUFFERLENGTH (AUDIO_BLOCKLENGTH * AUDIO_NUMBLOCKS) // length of audio buffer in samples

struct _AUDIO_BUFFER {
  short  Data[AUDIO_BUFFERLENGTH * 2];
  short *CurrentPosition;
  int    Filled;
} extern Audio_Buffer;

void Audio_Init(void);
void Audio_Quit(void);

#ifdef SDL

#define Audio_Pause(pause) {                          \
  if(!pause)                                          \
  {                                                   \
    memset(&Audio_Buffer, 0, sizeof(Audio_Buffer));   \
    Audio_Buffer.CurrentPosition = Audio_Buffer.Data; \
    SDL_PauseAudio(0);                                \
  }                                                   \
  else SDL_PauseAudio(1);                             \
}

#define Audio_Lock()   SDL_LockAudio()
#define Audio_Unlock() SDL_UnlockAudio()

#else

extern BOOL audio_locked, audio_paused;

#define Audio_Pause(pause) {                          \
  if(!pause)                                          \
  {                                                   \
    memset(&Audio_Buffer, 0, sizeof(Audio_Buffer));   \
    Audio_Buffer.CurrentPosition = Audio_Buffer.Data; \
  }                                                   \
  audio_paused = pause;                               \
}

#define Audio_Lock()   audio_locked = TRUE;
#define Audio_Unlock() audio_locked = FALSE;

#endif

#ifdef __cplusplus
}
#endif

#endif // _AUDIO_H
