
#ifndef _UTIL_H
#define _UTIL_H

// check if ASCII character c is a space character
#ifndef ISSPACE
#define ISSPACE(c) (((c) >= 0x09 && (c) <= 0x0D) || (c) == 0x20)
#endif
// check if ASCII character c is a digit character (0 to 9)
#ifndef ISDIGIT
#define ISDIGIT(c) (((c) >= '0') && ((c) <= '9'))
#endif
#ifndef ISHEXDIGIT
#define ISHEXDIGIT(c) (ISDIGIT(c) || ((c) >= 'A' && (c) <= 'F') || ((c) >= 'a' && (c) <= 'f'))
#endif

#ifdef __cplusplus
extern "C" {
#endif

char *GetTempFilePath(char *);            // create a path for a temporary file
char *GetFileExtFromPath(const char *);   // get extension from a file path
char *GetFileNameFromPath(const char *);  // get file name from a file path
int   RemoveExtremeSpaces(char *);        // remove spaces from the begining and the end of the string
long  Str2Int(const char *, long, int *); // read the number inside the string

#ifdef __cplusplus
}
#endif

#endif // _UTIL_H
